/**
 * @author v_wangyan
 */ 
function g(id) { 
	try{
		return document.getElementById(id);
	} catch(e) {
		Log('g failed');
		return '';
	}
}	
function randomInt (min, max) {
	return Math.floor(Math.random() * (max - min + 1) + min);
}
function jsonDecode(jsonString) {
	return (new Function("return " + jsonString))();
}
function show(id) {
	isShow(id, true);
}
function hide(id) {
	isShow(id, false);
}
function isShow(id, flag) {
	try{
	g(id).style.display = flag? 'block' : 'none';
} catch(e) { }
}
function addClass(element, className) {
	element = g(element)||element;
    var classArray = className.split(/\s+/),
        result = element.className,
        classMatch = " " + result + " ",
        i = 0,
        l = classArray.length;

    for (; i < l; i++) {
         if ( classMatch.indexOf( " " + classArray[i] + " " ) < 0 ) {
             result += (result ? ' ' : '') + classArray[i];
         }
    }

    element.className = result;
}
function removeClass(element, className) {
	element = g(element)||element;

    var oldClasses = element.className.split(/\s+/),
        newClasses = className.split(/\s+/),
        lenOld,
        lenDel = newClasses.length,
        j,
        i = 0;
    for (; i < lenDel; ++i) {
        for(j = 0, lenOld = oldClasses.length; j < lenOld; ++j) {
            if (oldClasses[j] == newClasses[i]) {
            	oldClasses.splice(j, 1);
            	break;
            }
        }
    }
    element.className = oldClasses.join(' ');
}
function createElement (className) {
	var div = document.createElement('div');
	div.className = className;
	return div;
}
function getSkinType(className, rule) {
	return className.split(rule).pop();
}
//获取当前皮肤风格状态
function getSkinStyle() {
	try{
	var clsName = g('main').className;
	clsName = clsName.split(' ').pop();
	clsName = clsName.split('-');
	if ( 1 < clsName.length) {
		return clsName[0] + '-';
	}
} catch(e) { }
	return '';
}
//获取参数
function execSync(order, param) {
	try {
		if (window.external.SyncRequest) {
			return window.external.SyncRequest(order,param);
		}
	} catch (e) {
		return false;
	}
	return false;
}
//执行命令
function execOrder(order, key) {
	try {
		window.external.SyncRequest(order, key);
	} catch (e) {}
}
/**
 * 设置存储值
 */
function setConfig(key, value) {
	try{
    var globalData = getConfigData() || {};
    globalData[key] = value;
    var str = '{';
    var sp = '';

    for (k in globalData) {
        if ('{' != str) {
            sp =',';
        }
        str += sp + '"' + k + '":"' + globalData[k] + '"';
    }

    str += '}';
    try {
    	 window.external.SyncRequest('saveConfig', str);
    } catch (e) {}   
} catch(e) { }
}
/**
 * 获取存储的值
 */
function getConfig(key) { 
	try{
    var globalData = getConfigData();
    if (globalData && typeof globalData[key] != 'undefined') { 
        return globalData[key];
    }
} catch(e) {  }

    return null;
}
function getConfigData() {
	try {
		if (window.external.SyncRequest) {
			var strJSON = window.external.SyncRequest('readConfig'); 
			strJSON= jsonDecode(strJSON);
			return strJSON;
		}  
	} catch (e) {
		 return null;
	}	
   
}
//给RD调用
function setButtonState(key, statu) {
	var status = skin.buttonstatus;
	var id = '';
	key = key || '0';
	try {
		id = status[key].id;
		statu =  statu || (g(id).getAttribute('statu') == '0' ? '1' : '0');		
		g(id).className = 'icon ' + status[key][statu];
		g(id).setAttribute ('statu', statu); 	
	} catch(e) {}
		
}
/**
 * 设置输入法状态  
 * 参数:0 (中英文切换)	返回值: 0 英文 1 中文;
 * 参数:1 (全半角切换)	返回值: 0 半角 1 全角; 
 * 参数:2 (中英文标点)	返回值: 0 英文标点 1 中文标点;
 * 参数:3 (软键盘)
 * 参数:4 (登录)			返回值: 0 未登录 1 已登录
 * 参数:5 (配置)
 */
function setIMEStatus() {
	try{
	setButtonState('0', getExecStatus('language', '0'));	
	setButtonState('1', getExecStatus('characters', '1'));	
	setButtonState('2', getExecStatus('punctuation', '2'));	
	setButtonState('4', getExecStatus('isLogin', '4'));	
} catch(e) { }
}
//获取RD数据status,null 时返回当前状态
function getExecStatus(id, key) { 
	try {
		var statu = execSync('getButtonState', key) || g(id).getAttribute('statu'); 
		return statu;
	} catch(e){
		return '0';
	}
	
}
//处理点击
function execMouseDown (e, rightClick, key) {
	//取消冒泡事件
	e.stopPropagation(); 
	
	var order = rightClick ? 'mouseRDown' : 'mouseLDown';
	execOrder(order, key);		
}
//右键点击
function rightButton(id) {
	if (event.button == 2) {
		execMouseDown(event, true, id);
	}
}
//设置页面显示的字体
function setFontFamily(key) {	//设置字体:  0-宋体 ; 1-微软雅黑;
	key = key || '0';
	var obj = document.body;
	var font = '';
	if (key) {
		font = '"微软雅黑", "宋体", Arial, Verdana';
	} else {
		font = '"宋体", "微软雅黑", Arial, Verdana';
	}
	obj.style.fontFamily = font;
}
//是否为win7--雅黑字
function getSysver() {
	var key = 0;
	try {
		key = window.external.SyncRequest('sysver');
		if ('6.1' == key) {
			key = 1;
		}
	} catch (e) {	}	
	
	setFontFamily(key);	
}
/**
 * 查看未来三天天气
 */
function checkFutureWeather(id, rule, flag) {
	try{
	var main = g(id);					
	if (flag) {
		main.className = 'main lately-' + getSkinType(main.className, rule);	
		show('trid');
	} else {
		main.className = 'main ' + getSkinType(main.className, rule);
		hide('trid');
	}			
	} catch(e) { }
} 
  
/**
 * 定时更改图片背景
 */
function changePosition(id, step, totalW, speed, loop, sleep) {
	try{
	var cX = 0;
	var num = 0;
	var count = loop;
	var effectKey = window.setInterval(function() {
		if (cX >= totalW) {
			window.clearInterval(effectKey);
			g(id).style.backgroundPosition = "0 0";
			if (count == 0 || --count > 0) {
				g(id).style.display = 'none';
				window.setTimeout(function() {
					g(id).style.display = 'block';
					changePosition(id, step, totalW, speed, count, sleep);							
					}, sleep);
				return;
			}
			return;
			}
		num++;
		cX = num*step;
		g(id).style.backgroundPosition = "-" + cX + "px 0" ;
		}, speed);
		} catch(e) { }
}  
/**
 * 获取季节
 */
function getSeason() {	
	var season = 'spring';
	try	{
		var t = new Date();
		var month = t.getMonth()+1;
		switch (month) {
			case 3:
			case 4:  
			case 5: season = 'spring'; break;
			case 6:
			case 7: 
			case 8: season = 'summer'; break;
			case 9:
			case 10: 
			case 11: season = 'autumn'; break;
			default: season = 'winter'; break;
		}
	}
	catch (e){	
		return season;
	}
	
	return season;
}
/**
 * 获取白天/晚上
 * 早7点到晚7点-白天
 */
function getTime() { 
	var now = getTimeNow();
	if ( 25199 < now && 68399 >now) {
		return 'daytime';
	} else {
		return 'night';
	}
}
function getTimeNow() {
	var t = new Date();
	var hours = t.getHours();
	var minutes = t.getMinutes();
	var seconds = t.getSeconds(); 
	 
	return hours*60*60+minutes*60+seconds*1;
}
//设置背景云层
function getBackgroundCloud(weathertype) {
	try{
	weathertype = weathertype || '';
	var bgcloud = skin.bgcloud;
	var couldCls = '';
	var len = bgcloud.type.length;
	for (var i = 0; i < len; i++) {
		for (var j = 0, l = bgcloud.type[i].length; j < l; j++ ) {
			if (weathertype == bgcloud.type[i][j]) {
				couldCls = bgcloud.cloudCls[i];
				return couldCls;
			}
		}
	}
	return bgcloud.cloudCls[len];
}
catch(e) {return ''; }
}
/**
 * 返回最大风力
 */
function getWindPower(wind) {//0-2级:不动;3-4级:	4.5s;5-6级:3s;7-8级:2s	
try{
	var regex = /.*?(\d+)-*(\d+)*.*/; console.log('wind:' +wind);
	var val = 3;	//默认风车转速为 最慢转速(3-4级)
	var num = 0;
	var result = wind.match(regex); 
	if (!result) {
		var datamap = skin.datamap.wind;
		for (var i = 0, len = datamap.maplist.length; i < len; i++) {
			if (datamap.maplist[i] == wind) {
				val = datamap.realList[i];
				return val;
			}
		}	
	}
	
	if (result && typeof result[1] != 'undefined') {
	    val = parseInt(result[1]);
	}
	if (result && typeof result[2] != 'undefined') {
		if(val < parseInt(result[2])) {
			val = parseInt(result[2]);
		}
	} 
	return val;
} catch(e) { return ''; }
}
/**
 * 返回气温对象: low为最低,high为最高
 */
function getTemperature(temp) {
	try{
	var t = temp.match(/(-*\d+).*?(-*\d+)/);
	var arr = {high: t[1].split(''), low: t[2].split('')}
	return arr;
} catch(e) { return ''; }
}
/**
 * 设置当天温度
 */
function setTemperature(temp, tempObj) {
	try{
	var i = 0;
	var backgroundImg = '';
	var bgWidth = 0; 
	if (tempObj[temp][0] != '-') { 
		hide(temp + 'Subzero');
	} else {
		show(temp + 'Subzero');
		i = 1;
	}
	for (; i<tempObj[temp].length; i++){
		if (backgroundImg != '') {
			backgroundImg = backgroundImg + ',';				
		}
		bgWidth += 10;
		backgroundImg = backgroundImg + 'url(images/icons/'+ tempObj[temp][i] +'.png)'; 
	}
	g(temp +'Temp').style.backgroundImage = backgroundImg;
	g(temp +'Temp').style.width = bgWidth + 'px';	
} catch(e) {  }
}
/**
 * 设置皮肤状态(精简模式-通用模式)
 */
function toggleStatus(id, status) {
	try{
		changeSkinSimple(status);
		g(id).onclick = function () {
			var reg = new RegExp(status);
			if (status && reg.test(g('main').className)) {
				status = '';
				changeSkinSimple('');
				
				g('trid').style.height = '0px';
				g('todayWeather').style.marginTop = '82px';
				g('otherWeather').style.height = '51px';
				g('effectWeather').style.top = '84px';
				
			} else {
				stop();
				
				status = 'simple';
				changeSkinSimple('simple');
				
				g('trid').style.height = '0px';
				g('otherWeather').style.height = '64px';
				g('effectWeather').style.top = '138px';
								
			}
		}
	} catch(e) { }
	}
function changeSkinSimple(className) {
	try{
	var effectTop = parseInt(g("effectWeather").style.top);
	if (className && className.length>0) {
		hide("todayWeather");
		hide("trid");
		g("otherWeather").style.height = "64px";
		addClass("otherWeather", "simple-cnt");
		g("effectWeather").style.top = (effectTop + 54) + "px";
	} else {
		show("todayWeather");
		show("trid");
		g("otherWeather").style.height = "51px";
		removeClass("otherWeather", "simple-cnt");
		g("effectWeather").style.top = (effectTop - 54) + "px";
	}
	g('main').className = 'main ' + ((className == '')? '': (className + '-')) +getTime();
} catch(e) { }
}
/**
 * 创建天气展示
 */
function createDomList(domList, weatherType) {
	try{
	var dayOrNight = getTime();
	var element = null;	
	// var childList = g('weather').getElementsByTagName('div');
	// for(j=4; j< childList.length; j++){
		// g('weather').removeChild(childList[j]);
	// }
	
	g('weather').innerHTML = '';
	if (('sunny' == weatherType) && ('night' == dayOrNight)) {
		element = createElement('sun');
		g('weather').appendChild(element);
		return;
	}

	
	for (i=0; i< domList.length; i++) {
		element = createElement(domList[i].clsName);
		
		if (typeof domList[i].childNode != 'undefined') {
			for (var j = 0, l = domList[i].childNode.length; j < l; j++) {
				element.appendChild(createElement(domList[i].childNode[j].clsName));
			}
		}
		
		g('weather').appendChild(element);
	}
} catch(e) { return ''; }
}
/**
 * 创建 地区列表
 */
function buildRegion(objUl, data) {
	try {
	objUl.innerHTML = '';
	var li = null;	
	for (i=0; i<data.length; i++) {
		li = document.createElement('li');
		if (data[i].citylist && data[i].citylist.length > 0) {
			li.setAttribute('hasChild', 'true');
		} else {
            li.onclick = function() {
                setCurrentCity(this);
            }
			li.setAttribute('hasChild', 'false');
		}
		li.id = data.id;
		li.innerHTML = data[i].province;	
		//城市列表
		li.onmouseover = function() { 
			addClass(this, 'active'); 
			if ('true' == this.getAttribute('hasChild')) {
				addClass(this, 'child'); 
				showChildNode(this);
				tmpRegion = this;
			} else {
				hide('city');
			}				
		}
		li.onmouseout = function() {
			this.className = '';	
		}
		
		objUl.appendChild(li);
	}
} catch(e) { }
}
/**
 * 创建城市列表
 */	
function buildCity(objUl, data) {
	try{
	objUl.innerHTML = '';
	var li = null;			
	for (ti=0; ti<data.length; ti++) {
		li = document.createElement('li');
		li.innerHTML = data[ti];
		li.onclick = function() {
			setCurrentCity(this);
		}
		
		objUl.appendChild(li);
	}			
} catch(e) { }
}
/**
 * 显示城市列表
 */
function showChildNode(objLi) {
	try{
	var data = province;
	var i = 0;
	for (; i< data.length; i++) {
		if (data[i].province == objLi.innerHTML) { 
			buildCity(g('cityList'), data[i].citylist);
			break;
		}
	}
	g('cityList').style.marginTop = '0px';
	pager('city', 'cityList', 18, 'Prev');
	if (data[i].citylist.length <= 6) {
		addClass('cityNext', 'next-disable');
		
	} else {
		removeClass('cityNext', 'next-disable');
	}
	show('city');		
} catch(e) { }
}
//城市列表-分页
function pager(btnId, listId, step, np) {
	try{
	var speed = 1;
	var clientHeight = 6 * step;
	var dirct = (np == 'Next') ? -1 : 1;
	var btnObj = g(btnId+np);
	var listObj = g(listId);
	var totalHeight = listObj.offsetHeight;
	var currentHeight = 0;
	var scroll = null;
	
	window.clearInterval(scroll);
	scroll = window.setInterval(function() {
		currentHeight = parseInt(listObj.style.marginTop);
		if (0 == step) {
			window.clearInterval(scroll);
			return;
		}
		
		if (-1 == dirct && totalHeight - Math.abs(currentHeight) <= clientHeight) {
			addClass(btnId+np, 'next-disable');
			window.clearInterval(scroll);
			return;
		} else if (1 == dirct && currentHeight >= 0) {
			addClass(btnId+np, 'prev-disable');
			window.clearInterval(scroll);
			return;
		}
		
		if (-1 == dirct) {
			removeClass(btnId+'Prev', 'prev-disable');
		} else {
			removeClass(btnId+'Next', 'next-disable');
		}
		
		listObj.style.marginTop = (currentHeight + speed * dirct)+ 'px';
		step--;
		
		var realHeight = parseInt(listObj.style.marginTop);
		if (1 == dirct && realHeight == 0) {
			addClass(btnId+np, 'prev-disable');
		} else if (-1 == dirct && totalHeight - Math.abs(realHeight) <= clientHeight) {
			addClass(btnId+np, 'next-disable');
		}
	}, 30);
} catch(e) { }
}

/**
 * 更改城市-存储城市
 */
function setCurrentCity(obj) {
	try{
	realCity = obj.innerHTML;
	g('currentCity').innerHTML = realCity;	
	setConfig('city', realCity);
	getWeather();
	hide('city');
	hide('region');
} catch(e) { }

}
/**
 * 映射天气
 */    
function weatherMap(weather) {
	var mapList = [
		'雷阵雨伴有冰雹',
		'大暴雨',
		'特大暴雨',
		'大暴雨转特大暴雨',
		'阵雪',
		'冻雨',
		'小到中雨',
		'小到中雨转多云',
		'小到中雨转雷阵雨',
		'大到暴雨',
		'大到暴雨转中雨',
		'大到暴雨转大雨',
		'大到暴雪',
		'小到中雨转中到大雨',
		'中到大雨转阵雨',
		'中到大雨',		
		'中到大雨转中雨',
		'浮尘',
		'强沙尘暴'
	];
	var realList = [
		'thundershowers',
		'rainstorm',
		'rainstorm',
		'rainstorm',
		'lightsnow',
		'lightrain',
		'lightrain',
		'lightrain',
		'lightrain',
		'heavyrain',
		'heavyrain',
		'heavyrain',
		'heavysnow',
		'moderaterain',
		'moderaterain',
		'moderaterain',		
		'moderaterain',
		'jansa',
		'sandstorms'
	];
	
	for (var i = 0,l = mapList.length; i < l;i++) {
		if (weather == mapList[i]) {
			return realList[i];
		}
	}
	
	for (otherWeather in skin.weatherkey) {
		var regex = new RegExp('^' + skin.weatherkey[otherWeather].title);
		if (regex.test(weather)) {
			return otherWeather;
		}
	}

	return 'sunny';
}     
    
/**
 * 风车转动-风力
 * @param pause: 转动速度(1-4 4为3/4级风转速,为最慢)
 */
function animateWindmill(pause) {
	try{
    	if (windPower % pause !=0) {
    		windPower++;
    		return;
    	} else {
    		windPower=1;
    	}
    	
    	if (fanNum == 90) { 
    		fanNum = 0;
    	} else {
    		fanNum++;
    	}
    	//f.style.backgroundPosition = -fanNum * fanWidth + 'px 0px';
} catch(e) { }
}
/**
 * @param target: 
 * @param value: 当前透明值
 * @param flag: 是否透明
 */
function setOpacity(target, value, flag) {
	try{
	if (flag) { 
		value = value + 4; 
		if (value > 100) { 
			isFadeOut = true;
			return;
		} 
	} else { 
		value = value - 4; 
		if (value < 0) {  
			return;
		} 
	}	
	val = value;
	target.style.opacity = (value / 100); 
	target.style.filter = 'alpha(opacity=' + value + ')'; 
} catch(e) { }
}
//展开天气面板
var Move_IntervalID;
function stop () { 
	window.clearInterval(Move_IntervalID);
}
function slideMoudle(){
	var minNO=51;
	var maxNO=134;	

	g("todayWeather").style.marginTop="82px";
	g("otherWeather").style.height = "51px";
	g("effectWeather").style.top = "84px";
	g("trid").style.height = 0;

	g("todayWeather").onmouseover=function () {
		move(true);
	}
	g("todayWeather").onmouseout=function () {
		move(false);
	}
	g("trid").onmouseover=function () {
		move(true);
	}
	g("trid").onmouseout=function () {
		move(false);
	}	
	function move(isUp) {
		try{
		stop();
		var cH = parseInt(g("otherWeather").style.height); 
		var cMT = parseInt(g("todayWeather").style.marginTop); 
		var effect = parseInt(g("effectWeather").style.top);
		var tridHeight = parseInt(g("trid").style.height);
		var step = 1;
		Move_IntervalID = window.setInterval(function() {
			if (isUp) {
				cH+=step;
				if (cH > maxNO) {
					stop();
					return;					
				}
				cMT -= step;
				effect -= step;
				tridHeight += step;
			} else {
				cH -= step;
				if (cH < minNO) {
					stop();
					return;					
				}
				cMT += step;
				effect += step;
				tridHeight -= step;
				}
			g("otherWeather").style.height = cH+"px";
			g("todayWeather").style.marginTop = cMT+"px";
			g("effectWeather").style.top = effect + "px"; 
			g("trid").style.height = tridHeight + "px";
		},1)
	} catch(e) { }
	}
}


//打印log
function Log(str) {
	try {
		if(window.external.SyncRequest)
		{
			window.external.SyncRequest('log', str);
		}
		else
		{
			console.log(str);
		}
	} catch (e) {}
}
