﻿var province = [
	{
		'id':'1',
		'province':'北京',
		'citylist':[]
	},
	{
		'id':'2',
		'province':'天津',
		'citylist':[]
	},
	{
		'id':'3',
		'province':'河北',
		'citylist':['石家庄','保定','沧州','承德','邯郸','衡水','廊坊','秦皇岛','唐山','邢台','张家口']
	},
	{
		'id':'4',
		'province':'河南',
		'citylist':['郑州','安阳','济源','鹤壁','焦作','开封','洛阳','漯河','南阳','平顶山','濮阳','三门峡','商丘','新乡','信阳','许昌','周口','驻马店']
	},
	{
		'id':'5',
		'province':'山西',
		'citylist':['太原','长治','大同','晋城','晋中','临汾','吕梁','朔州','忻州','阳泉','运城']
	},
	{
		'id':'6',
		'province':'内蒙古',
		'citylist':['呼和浩特','包头','赤峰','鄂尔多斯','呼伦贝尔','通辽','乌海','兴安']
	},
	{
		'id':'7',
		'province':'山东',
		'citylist':['济南','滨州','德州','东营','菏泽','济宁','莱芜','聊城','临沂','青岛','日照','泰安','威海','潍坊','烟台','枣庄','淄博']
	},
	{
		'id':'8',
		'province':'江苏',
		'citylist':['南京','常州','淮安','连云港','南通','苏州','宿迁','泰州','无锡','徐州','盐城','扬州','镇江']
	},
	{
		'id':'9',
		'province':'浙江',
		'citylist':['杭州','湖州','嘉兴','金华','丽水','宁波','衢州','绍兴','台州','温州','舟山']
	},
	{
		'id':'10',
		'province':'上海',
		'citylist':[]
	},
	{
		'id':'11',
		'province':'安徽',
		'citylist':['合肥','安庆','蚌埠','亳州','巢湖','池州','滁州','阜阳','淮北','淮南','黄山','六安','马鞍山','宿州','铜陵','芜湖','宣城']
	},
	{
		'id':'12',
		'province':'辽宁',
		'citylist':['沈阳','鞍山','本溪','朝阳','大连','丹东','抚顺','阜新','葫芦岛','锦州','辽阳','盘锦','铁岭','营口']
	},
	{
		'id':'13',
		'province':'吉林',
		'citylist':['长春','白城','白山','吉林','辽源','四平','松原','通化']
	},
	{
		'id':'14',
		'province':'黑龙江',
		'citylist':['哈尔滨','大庆','大兴安岭','鹤岗','黑河','鸡西','佳木斯','牡丹江','七台河','齐齐哈尔','双鸭山','绥化','伊春']
	},
	{
		'id':'15',
		'province':'广东',
		'citylist':['广州','潮州','东莞','佛山','河源','惠州','江门','揭阳','茂名','梅州','清远','汕头','汕尾','韶关','深圳','阳江','云浮','湛江','肇庆','中山','珠海']
	},
	{
		'id':'16',
		'province':'广西',
		'citylist':['桂林','百色','北海','崇左','防城港','贵港','河池','贺州','来宾','柳州','南宁','钦州','梧州','玉林']
	},
	{
		'id':'17',
		'province':'福建',
		'citylist':['福州','龙岩','南平','宁德','莆田','泉州','三明','厦门','漳州']
	},
	{
		'id':'18',
		'province':'海南',
		'citylist':['海口','临高','保亭','昌江','澄迈','儋州','定安','东方','乐东','白沙','陵水','琼海','琼中','三亚','屯昌','万宁','文昌','五指山',]
	},
	{
		'id':'19',
		'province':'湖南',
		'citylist':['长沙','常德','郴州','衡阳','怀化','娄底','邵阳','湘潭','益阳','永州','岳阳','张家界','株洲']
	},
	{
		'id':'20',
		'province':'江西',
		'citylist':['南昌','抚州','赣州','吉安','景德镇','九江','萍乡','上饶','新余','宜春','鹰潭']
	},
	{
		'id':'21',
		'province':'湖北',
		'citylist':['武汉','鄂州','恩施','黄冈','襄阳','黄石','荆门','荆州','潜江','神农架','十堰','随州','天门','仙桃','咸宁','襄樊','孝感','宜昌']
	},
	{
		'id':'22',
		'province':'云南',
		'citylist':['昆明','保山','楚雄','大理','德宏','红河','丽江','临沧','怒江','曲靖','思茅','文山','玉溪','昭通']
	},
	{
		'id':'23',
		'province':'贵州',
		'citylist':['贵阳','安顺','毕节','铜仁','遵义']
	},
	{
		'id':'24',
		'province':'四川',
		'citylist':['成都','阿坝','巴中','达州','德阳','德州','甘孜','广安','广元','乐山','凉山','泸州','眉山','绵阳','内江','南充','攀枝花','遂宁','雅安','宜宾','资阳','自贡']
	},
	{
		'id':'25',
		'province':'重庆',
		'citylist':[]
	},
	{
		'id':'26',
		'province':'陕西',
		'citylist':['西安','安康','宝鸡','杨凌','汉中','商洛','铜川','渭南','咸阳','延安','榆林']
	},
	{
		'id':'27',
		'province':'甘肃',
		'citylist':['兰州','白银','敦煌','定西','甘南','嘉峪关','金昌','酒泉','临夏','平凉','庆阳','天水','武威','张掖']
	},
	{
		'id':'28',
		'province':'宁夏',
		'citylist':['银川','固原','石嘴山','吴忠','中卫']
	},
	{
		'id':'29',
		'province':'青海',
		'citylist':['西宁','玉树']
	},
	{
		'id':'30',
		'province':'新疆',
		'citylist':['乌鲁木齐','阿克苏','阿拉尔','阿勒泰','昌吉','哈密','和田','喀什','克拉玛依','石河子','塔城','吐鲁番']
	},
	{
		'id':'31',
		'province':'西藏',
		'citylist':['拉萨','阿里','昌都','林芝','那曲','日喀则','山南']
	},
	{
		'id':'32',
		'province':'台湾',
		'citylist':[]
	},
	{
		'id':'33',
		'province':'香港',
		'citylist':[]
	},
	{
		'id':'34',
		'province':'澳门',
		'citylist':[]
	},
]