/**
 * @author v_wangyan
 */
var skin = {
	effect:{
		'fan':{
			'id': "fan",
			'step': 60,
			'totalWidth':5460,
			'speed': 50,
			'loop':0,
			'delay':0 
		},
		'raindrop':{
			'id': "raindrop",
			'step': 50,
			'totalWidth':2100,
			'speed': 40,
			'loop':0,
			'delay':1 
		},
		'jansa':{
			'id': "jansa",
			'step': 50,
			'totalWidth':2100,
			'speed': 40,
			'loop':0,
			'delay':1
		},
		'sunshine':{
			'id': "sunshine",
			'step': 80,
			'totalWidth':2100,
			'speed': 40,
			'loop':0,
			'delay':2
		}
	},
	weatherkey:{
		'sunny':{
			'title':'晴',
			'domlist':[
				{
					'clsName':'sun sun-shine' 
				},
				{
					'clsName':'sunlight' 
				}]
		},
		'cloudy':{
			'title':'多云',
			'domlist':[
				{
					'clsName':'sun'
				},
				{
					'clsName':'cloudy',
					'childNode':[
						{
							'clsName':'cloudy-left'
						},
						{
							'clsName':'cloudy-right'
						},
						{
							'clsName':'cloudy-center'
						}
					]
				}
			]
		},
		'foggy':{
			'title':'雾',
			'domlist':[
				{
					'clsName':'sun'
				},
				{
					'clsName':'foggy'
				}
			]
			
		},
		'overcast':{
			'title':'阴',
			'domlist':[
				{
					'clsName': 'rain-cloud'
				},
				{
					'clsName': 'rain-cloud rain-cloud2'
				}
			]
		},
		'jansa':{
			'title':'扬沙',
			'domlist':[
				{
					'clsName':'jansa'
				},
				{
					'clsName':'jansa-wind'
				}
			]
		},
		'sandstorms':{
			'title':'沙尘暴',
			'domlist':[
				{
					'clsName':'sun'
				},
				{
					'clsName':'sandstorm',
					'childNode':[
						{
							'clsName':'storm'
						},
						{
							'clsName':'grit'
						}
					]
				}
			]
		},
		'hailstone':{
			'title':'冰雹',
			'domlist':[
				{
					'clsName':'hail'
				},
				{
					'clsName':'hail hail2'
				},
				{
					'clsName':'hail hail3'
				},
				{
					'clsName':'hail hail4'
				},
				{
					'clsName':'hail hail5'
				},
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				}
			]
		},
		'lightrain':{
			'title':'小雨',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'raindrop raindrop1'
				},
				{
					'clsName':'raindrop raindrop2'
				}
			]
		},
		'moderaterain':{
			'title':'中雨',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'raindrop raindrop1'
				},
				{
					'clsName':'raindrop raindrop2'
				},
				{
					'clsName':'raindrop raindrop3'
				},
				{
					'clsName':'raindrop raindrop4'
				},
				{
					'clsName':'raindrop raindrop5'
				}
			]
		},
		'heavyrain':{
			'title':'大雨',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud1'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'raindrop raindrop1'
				},
				{
					'clsName':'raindrop raindrop2'
				},
				{
					'clsName':'raindrop raindrop3'
				},
				{
					'clsName':'raindrop raindrop4'
				},
				{
					'clsName':'raindrop raindrop5'
				},
				{
					'clsName':'raindrop raindrop6'
				},
				{
					'clsName':'raindrop raindrop7'
				}
			]
		},
		'rainstorm':{
			'title':'暴雨',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud1'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'raindrop raindrop1'
				},
				{
					'clsName':'raindrop raindrop2'
				},
				{
					'clsName':'raindrop raindrop3'
				},
				{
					'clsName':'raindrop raindrop4'
				},
				{
					'clsName':'raindrop raindrop5'
				},
				{
					'clsName':'raindrop raindrop6'
				},
				{
					'clsName':'raindrop raindrop7'
				},
				{
					'clsName':'raindrop raindrop8'
				},
				{
					'clsName':'raindrop raindrop9'
				}		
			]
		},
		'showeryrain':{
			'title':'阵雨',
			'domlist':[
				{
					'clsName':'rain-cloud cloud-shower'
				},
				{
					'clsName':'rain-cloud rain-cloud1 cloud-shower'
				},
				{
					'clsName':'sun sun-shower'
				},
				{
					'clsName':'raindrop raindrop1'
				},
				{
					'clsName':'raindrop raindrop2'
				},
				{
					'clsName':'raindrop raindrop3'
				},
				{
					'clsName':'raindrop raindrop4'
				}
			]
		},
		'thundershowers':{
			'title':'雷阵雨',
			'domlist':[
				{
					'clsName':'rain-cloud cloud-shower'
				},
				{
					'clsName':'rain-cloud rain-cloud1 cloud-shower'
				},
				{
					'clsName':'sun sun-shower'
				},
				{
					'clsName':'raindrop raindrop1'
				},
				{
					'clsName':'raindrop raindrop2'
				},
				{
					'clsName':'raindrop raindrop3'
				},
				{
					'clsName':'raindrop raindrop4'
				},
				{
					'clsName':'lightning'
				}
			]
		},
		'lightsnow':{
			'title':'小雪',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'snowman'
				},
				{
					'clsName':'snowflake'
				},
				{
					'clsName':'snowflake snowflake1'
				}				
			]
		},
		'moderatesnow':{
			'title':'中雪',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'snowman'
				},
				{
					'clsName':'snowflake'
				},
				{
					'clsName':'snowflake snowflake1'
				},
				{
					'clsName':'snowflake snowflake2'
				},
				{
					'clsName':'snowflake snowflake3'
				},
				{
					'clsName':'snowflake snowflake4'
				}
			]
		},
		'heavysnow':{
			'title':'大雪',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud1'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'snowman'
				},
				{
					'clsName':'snowflake'
				},
				{
					'clsName':'snowflake snowflake1'
				},
				{
					'clsName':'snowflake snowflake2'
				},
				{
					'clsName':'snowflake snowflake3'
				},
				{
					'clsName':'snowflake snowflake5'
				},
				{
					'clsName':'snowflake snowflake6'
				}
			]
		},
		'snowstorm':{
			'title':'暴雪',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud1'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'snowman'
				},
				{
					'clsName':'snowflake'
				},
				{
					'clsName':'snowflake snowflake1'
				},
				{
					'clsName':'snowflake snowflake2'
				},
				{
					'clsName':'snowflake snowflake3'
				},
				{
					'clsName':'snowflake snowflake4'
				},
				{
					'clsName':'snowflake snowflake5'
				},
				{
					'clsName':'snowflake snowflake6'
				},
				{
					'clsName':'snowflake snowflake7'
				},
				{
					'clsName':'snowflake snowflake8'
				}
			]
		},
		'rainandsnow':{
			'title':'雨夹雪',
			'domlist':[
				{
					'clsName':'rain-cloud'
				},
				{
					'clsName':'rain-cloud rain-cloud2'
				},
				{
					'clsName':'snowman'
				},
				{
					'clsName':'raindrop'
				},
				{
					'clsName':'raindrop raindrop2'
				},
				{
					'clsName':'snowflake'
				},
				{
					'clsName':'snowflake snowflake1'
				}
			]
		}
	},
	weather:[
		{
			"city":"天津",
			"cityid":"101010100",
			"temp1":"22~-6℃",
			"weather1":"雨夹雪转晴",
			"wind1":"东风4-5级",
			'item2':'明天',
			"temp2":"22~14℃",
			"weather2":"中雨",
			"wind2":"东风4-5级",
			'item3':'后天',
			"temp3":"18~14℃",
			"weather3":"阴转阵雨",
			"wind3":"东风4-5级",
		},
		{
			'error':'',
			'data':{
				'key':'长沙天气',
				'display' :
				{
					  'url':'http://www.weather.com.cn/weather/101250101.shtml' ,
					  'time0':'周一' ,
					  'weather0':'中雨' ,
					  'wind0':'南风' ,
					  'temp0':'21~10℃' ,
					  'time1':'周二' ,
					  'weather1':'雷阵雨' ,
					  'wind1':'东风5-6级' ,
					  'temp1': "-10~-12℃" ,
					  'time2':'周三' ,
					  'weather2':'多云' ,
					  'wind2':'微风' ,
					  'temp2':'25～16℃' ,
					  'time3':'周四' ,
					  'weather3':'多云' ,
					  'wind3':'北风' ,
					  'temp3':'25～18℃' 
	        	}
			}
		}
	],
	buttonstatus:[
		{
			'id':'language',
			'0':'english',
			'1':'chinese',
			'2':'capslock'				
		},
		{
			'id':'characters',
			'0':'half',
			'1':'full'			
		},
		{
			'id':'punctuation',
			'0':'en-punctuation',
			'1':'cn-punctuation',
		}
		,
		{
			'0':''
		}
		,
		{
			'id':'isLogin',
			'0':'logout',
			'1':'login'
		}
		,
		{
			'0':''
		}
	],
	bgcloud:{
		cloudCls:['cloud cloud-rain', 'cloud cloud-snow', 'cloud'],
		type:[
			['sandstorms', 'hailstone', 'lightrain', 'moderaterain', 'heavyrain', 'rainstorm', 'showeryrain', 'thundershowers', ''],
			['lightsnow', 'moderatesnow', 'heavysnow', 'snowstorm', 'rainandsnow']
		]
	},
	datamap:{
		wind:{
			maplist:['微风'],
			realList:[0],
			
		}
	}
}
